/*
 * Created on Nov 23, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.hrbfa.iceditor.controller;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.oreilly.servlet.multipart.FilePart;
import com.oreilly.servlet.multipart.MultipartParser;
import com.oreilly.servlet.multipart.ParamPart;
import com.oreilly.servlet.multipart.Part;

/**
 * @author Vijay Oruganty
 * 
 */
public class RequestProcessor {

	public void process(final HttpServletRequest request,
			final HttpServletResponse response,
			final ServletContext servletContext) {
		
		/*
		 * Upload Directory
		 * It is the absolute path to the web app's 'images' directory, in our case 'ic_editor' (under ic_editor the eclipse project root) 
		 * is the web root and the directory 'images' is under this.
		 * Hard coded this for now, it can be part of properties files or init parameters
		 */ 		
		File dir = new File("C:/work/ic_editor/ic_editor/images/");
		try {
		    PrintWriter out = response.getWriter();
		    response.setContentType("text/html");
			MultipartParser mp = new MultipartParser(request, 1 * 1024 * 1024); // 10MB
			Part part = null;
			while ((part = mp.readNextPart()) != null) {
				String name = part.getName();
				if (part.isParam()) {
					// it's a parameter part
					ParamPart paramPart = (ParamPart) part;
					String value = paramPart.getStringValue();
					// Just print any regular params to the console, it should have been to a log file, but ...
					System.out.println("param; name=" + name + ", value=" + value);
				} else if (part.isFile()) {
					// it's a file part
					FilePart filePart = (FilePart) part;
					String fileName = filePart.getFileName();
					if (fileName != null) {
						// the part actually contained a file
						long size = filePart.writeTo(dir);
						// The file has been uploaded to the images directory which is relative to the web root context 
						String uploadFile = "images/" + fileName;
						out.println("{status:'UPLOADED',image_url:'" + uploadFile +"'}");
					} else {
						 out.println("{status:'Error Reading Uploaded File.'}");
					}					
				}
			}			
		} catch (IOException e) {
			//it should have been to a log file, but ...
			System.out.println("Following exception occured while trying to upload the file, the actual message is: " + e.getMessage());
			e.printStackTrace();
		}
	}
}